#ifndef _CoherentHierarchicalCullingManager_H__
#define _CoherentHierarchicalCullingManager_H__

#include "CullingManager.h"
#include "HierarchyInterface.h"


namespace GtpVisibility
{

typedef std::pair<HierarchyNode *, OcclusionQuery *> QueryPair;
typedef std::queue<QueryPair> QueryQueue;

/** Renders the scene with the coherent hierarchical culling algorithm. 
*/
class CoherentHierarchicalCullingManager : public CullingManager
{
public:
	CoherentHierarchicalCullingManager(HierarchyInterface *hierarchyInterface);
	void RenderScene();
};

} // namespace GtpVisibility

#endif // CoherentHierarchicalCullingManager_H
